# coding: utf-8
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'git_fusion_strings/version'

Gem::Specification.new do |spec|
  spec.name          = "git_fusion_strings"
  spec.version       = GitFusionStrings::VERSION
  spec.authors       = ["Patrycja Tomiak"]
  spec.email         = ["patrycjatomiak@gmail.com"]

  spec.summary       = %q{Strings helpers for GitFusion}
  spec.description   = %q{Collection of methods to help while working with GitFusion strings}
  spec.homepage      = "https://swarm.workshop.perforce.com/projects/perforce-software-helix-web-services/"
  spec.license       = "MIT"

  # Prevent pushing this gem to RubyGems.org by setting 'allowed_push_host', or
  # delete this section to allow pushing this gem to any host.
  if spec.respond_to?(:metadata)
    spec.metadata['allowed_push_host'] = "TODO: Set to 'http://mygemserver.com'"
  else
    raise "RubyGems 2.0 or newer is required to protect against public gem pushes."
  end

  spec.files         = Dir.glob('bin/**/*') +
    Dir.glob('lib/**/*') +
    Dir.glob('spec/**/*') +
    %w(
      Gemfile
      git_fusion_strings.gemspec
      README.md
    )
  spec.bindir        = "exe"
  spec.executables   = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ["lib"]

  spec.add_development_dependency 'bundler', '~> 1.8'
  spec.add_development_dependency 'rspec'
  spec.add_development_dependency 'rake', '~> 10.0'
end
