require 'spec_helper'

describe GitFusionStrings do
  context '#gf_encode,#gf_decode' do
    it "ensure a repo name doesn't have a forward slash" do
      str = 'test/string'
      encoded = GitFusionStrings.encode(str)
      expect(encoded).to_not include('/')
    end

    it 'ensure a repo name with a forward slash can be decoded back' do
      str = 'test/string'
      encoded = GitFusionStrings.encode(str)
      decoded = GitFusionStrings.decode(encoded)
      expect(decoded).to eq(str)
    end

    it 'will not modify a string without special characters' do
      str = 'test_string'
      encoded = GitFusionStrings.encode(str)
      expect(str).to eq(encoded)
    end
  end
end